#!/usr/bin/perl
use Socket;
use Mysql;

#    PollWorld SQL v1.3 - poll management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<pw.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}

$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);
if ($ENV{CONTENT_LENGTH}>0){sysread(STDIN,$data,$ENV{CONTENT_LENGTH});}
else {($data=$ENV{QUERY_STRING});}
@data=split("&",$data);
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex($1))/eg;
		if ($data{$field}){$data{$field}="$data{$field},$value";}
		else {$data{$field}=$value;}
	}
}
$encline="$data{name}:".crypt($data{password},$data{password});
$destination=$data{method};
$destination="genset" unless ($destination);

$admpass="$alogin:$apassword";
&$destination if ($admpass eq $encline);
&closedb;
open (F,"<$pwpath/template/errautha.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage=~s/\@/\\\@/g;
$htmlpage=~s/\~/\\\~/g;
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;

sub genset
{
&closedb;
open (F,"<$pwpath/template/agenset.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage=~s/\@/\\\@/g;
$htmlpage=~s/\~/\\\~/g;
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub maillist
{
$sth=$dbh->query("LOCK TABLES pw_users READ") if ($locktables);
$sth=$dbh->query("SELECT COUNT(DISTINCT email) FROM pw_users");
$total=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&closedb;
open (F,"<$pwpath/template/amail.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage=~s/\@/\\\@/g;
$htmlpage=~s/\~/\\\~/g;
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub general
{
open(F,">pw.cfg");
flock(F,$LOCK_EX);
print F qq~#    PollWorld SQL v1.3 - poll management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

\$pwpath="$data{pwpath}";
\$backuppath="$data{backuppath}";
\$cgi="$data{cgi}";
\$pollworld="$data{pollworld}";
\$sysid="$data{sysid}";
\$progmail="$data{progmail}";
\$email='$data{email}';
\$furl="$data{furl}";
\$owntitle="$data{owntitle}";
\$delay=$data{delay};
\$twidth=$data{twidth};
\$alogin='$alogin';
\$apassword='$apassword';
\$mysqlhost="$data{mysqlhost}";
\$mysqldb="$data{mysqldb}";
\$mysqllogin="$data{mysqllogin}";
\$mysqlpassword="$data{mysqlpassword}";
\$locktables=$data{locktables};
\$license="$license";
\%cal=('Jan','1','Feb','2','Mar','3','Apr','4','May','5','Jun','6','Jul','7','Aug','8','Sep','9','Oct','10','Nov','11','Dec','12');
~;
flock(F,$LOCK_UN);
close(F);
open (F, "<pw.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
&genset;
}
sub admdata
{
$data{name}=$data{alogin};
$data{password}=$data{apassword};
$data{apassword}=crypt($data{apassword},$data{apassword});
open(F,">pw.cfg");
flock(F,$LOCK_EX);
print F qq~#    PollWorld SQL v1.3 - poll management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

\$pwpath="$pwpath";
\$backuppath="$backuppath";
\$cgi="$cgi";
\$pollworld="$pollworld";
\$sysid="$sysid";
\$progmail="$progmail";
\$email='$email';
\$furl="$furl";
\$owntitle="$owntitle";
\$delay=$delay;
\$twidth=$twidth;
\$alogin='$data{alogin}';
\$apassword='$data{apassword}';
\$mysqlhost="$mysqlhost";
\$mysqldb="$mysqldb";
\$mysqllogin="$mysqllogin";
\$mysqlpassword="$mysqlpassword";
\$locktables=$locktables;
\$license="$license";
\%cal=('Jan','1','Feb','2','Mar','3','Apr','4','May','5','Jun','6','Jul','7','Aug','8','Sep','9','Oct','10','Nov','11','Dec','12');
~;
flock(F,$LOCK_UN);
close(F);
open (F, "<pw.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
&genset;
}
sub a_maillist
{
$sth=$dbh->query("LOCK TABLES pw_users READ") if ($locktables);
$sth=$dbh->query("SELECT DISTINCT email FROM pw_users");
@emails=$sth->fetchcol;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$count=0;
if (@emails>0)
{
foreach(@emails)
{
$count++;
open (MAIL,"|$progmail");
print MAIL "To: $_\n";
print MAIL "From: $email ($owntitle)\n";
print MAIL "Subject: $data{subject}\n\n";
print MAIL "$data{body}\n\n";
print MAIL "\n.\n";
close (MAIL);
}
}
&closedb;
open (F,"<$pwpath/template/amail2.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage=~s/\@/\\\@/g;
$htmlpage=~s/\~/\\\~/g;
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub systools
{
$status.="Backup system status:<br>";
($atime,$mtime)=(stat("$_$file"))[8,9];
opendir(Dir,"$backuppath");
@files=readdir(Dir);
closedir(Dir);
shift(@files);
shift(@files);
shift(@files) if ($files[0] eq "log.db");
if (@files)
{
	($atime,$mtime)=(stat("$backuppath/$files[0]"))[8,9];
	($day,$month,$date,$time,$year)=split(" ",scalar localtime($mtime));
	$status.="Database was backed up on $date/$month/$year $time";
}
else
{
	$status.="Database wasnt backed up.";
}
&closedb;
open (F,"<$pwpath/template/asystools.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub backup_data
{
$sth=$dbh->query("LOCK TABLES pw_users WRITE, pw_polls WRITE") if ($locktables);
$sth=$dbh->query("BACKUP TABLE pw_users,pw_polls TO '$backuppath'");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES pw_users READ") if ($locktables);
$sth=$dbh->query("SELECT uid FROM pw_users");
@uids=$sth->fetchcol;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
foreach $uid(@uids)
{
$sth=$dbh->query("LOCK TABLES pw_stats_$uid WRITE, pw_ip_$uid WRITE") if ($locktables);
$sth=$dbh->query("BACKUP TABLE pw_stats_$uid,pw_ip_$uid TO '$backuppath'");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
&systools;
}
sub delete_backup
{
opendir(Dir,"$backuppath");
@files=readdir(Dir);
closedir(Dir);
shift(@files);
shift(@files);
foreach(@files)
{
	unlink("$backuppath/$_") if ($_ ne "log.db");
}
&systools;
}
sub install_backup
{
opendir(Dir,"$backuppath");
@files=readdir(Dir);
closedir(Dir);
shift(@files);
shift(@files);
shift(@files) if ($files[0] eq "log.db");
if(@files)
{
	$sth=$dbh->query("LOCK TABLES pw_users WRITE, pw_polls WRITE") if ($locktables);
	$sth=$dbh->query("DROP TABLE pw_users,pw_polls");
	$sth=$dbh->query("RESTORE TABLE pw_users,pw_polls FROM '$backuppath'");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	$sth=$dbh->query("LOCK TABLES pw_users READ") if ($locktables);
	$sth=$dbh->query("SELECT uid FROM pw_users");
	@uids=$sth->fetchcol;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	foreach $uid(@uids)
	{
		$sth=$dbh->query("LOCK TABLES pw_stats_$uid WRITE, pw_ip_$uid WRITE") if ($locktables);
		$sth=$dbh->query("DROP TABLE pw_stats_$uid,pw_ip_$uid");
		$sth=$dbh->query("RESTORE TABLE pw_stats_$uid,pw_ip_$uid FROM '$backuppath'");
		$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	}
}
&systools;
}
sub sql_dump
{
$file="CREATE TABLE pw_users (uid MEDIUMINT(6) UNSIGNED NOT NULL auto_increment, username VARCHAR(8) NOT NULL, password VARCHAR(8) NOT NULL, email VARCHAR(255) NOT NULL, status TINYINT(1), PRIMARY KEY (uid), INDEX (uid));\n";
$sth=$dbh->query("LOCK TABLES pw_users READ") if ($locktables);
$sth=$dbh->query("SELECT * FROM pw_users");
while (($uid,$username,$password,$email,$status)=$sth->fetchrow)
{
	push(@uids,$uid);
	$file.="INSERT INTO pw_users (uid,username,password,email,status) VALUES ($uid,'$username','$password','$email',$status);\n"
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$file.="CREATE TABLE pw_polls (pid MEDIUMINT(8) UNSIGNED NOT NULL auto_increment, uid MEDIUMINT(6) UNSIGNED NOT NULL, title VARCHAR(255), question VARCHAR(255), rdig MEDIUMINT(8), delay MEDIUMINT(3), expdate DATE, type TINYINT(1), PRIMARY KEY (pid), INDEX (pid,uid));\n";
$sth=$dbh->query("LOCK TABLES pw_polls READ") if ($locktables);
$sth=$dbh->query("SELECT * FROM pw_polls");
while (($pid,$uid,$title,$question,$rdig,$delay,$expdate,$type)=$sth->fetchrow)
{
	$delay=0 unless ($delay);
	$rdig="NULL" unless ($rdig);
	$file.="INSERT INTO pw_users (pid,uid,title,question,rdig,delay,expdate,type) VALUES ($pid,$uid,'$title','$question',$rdig,$delay,'$expdate',$type);\n"
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
foreach $uid(@uids)
{
$file.="CREATE TABLE pw_stats_$uid (aid MEDIUMINT(6) UNSIGNED NOT NULL auto_increment,pid MEDIUMINT(8) UNSIGNED NOT NULL,answer VARCHAR(255),hits MEDIUMINT(8),PRIMARY KEY (aid),INDEX (aid,pid));\n";
$sth=$dbh->query("LOCK TABLES pw_stats_$uid READ") if ($locktables);
$sth=$dbh->query("SELECT * FROM pw_stats_$uid");
while (($aid,$pid,$answer,$hits)=$sth->fetchrow)
{
	$file.="INSERT INTO pw_stats_$uid (aid,pid,answer,hits) VALUES ($aid,$pid,'$answer',$hits);\n"
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$file.="CREATE TABLE pw_ip_$uid (ipid MEDIUMINT(6) UNSIGNED NOT NULL auto_increment,pid MEDIUMINT(8) UNSIGNED NOT NULL,ip VARCHAR(15),expdt DATETIME,PRIMARY KEY (ipid),INDEX (ip));\n";
$sth=$dbh->query("LOCK TABLES pw_ip_$uid READ") if ($locktables);
$sth=$dbh->query("SELECT * FROM pw_ip_$uid");
while (($ipid,$pid,$ip,$expdt)=$sth->fetchrow)
{
	$file.="INSERT INTO pw_ip_$uid (ipid,pid,ip,expdt) VALUES ($ipid,$pid,'$ip','$expdt');\n"
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
&closedb;
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-disposition: filename=\"pw_tables.sql\"; \n";
print "content-type: application/sqldump\n\n";
print $file;
exit;
}
sub reset_db
{
&closedb;
open (F,"<$pwpath/template/ardb.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub reset_db1
{
if ($data{type} eq "all")
{
	$sth=$dbh->query("LOCK TABLES pw_users READ") if ($locktables);
	$sth=$dbh->query("SELECT uid FROM pw_users");
	@uids=$sth->fetchcol;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	foreach $uid(@uids)
	{
		$sth=$dbh->query("DROP TABLE pw_stats_$uid, pw_ip_$uid");
	}
	$sth=$dbh->query("LOCK TABLES pw_users WRITE, pw_polls WRITE") if ($locktables);
	$sth=$dbh->query("DELETE FROM pw_users");
	$sth=$dbh->query("DELETE FROM pw_polls");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
elsif ($data{type} eq "lockip")
{
	$sth=$dbh->query("LOCK TABLES pw_users READ") if ($locktables);
	$sth=$dbh->query("SELECT uid FROM pw_users");
	@uids=$sth->fetchcol;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	foreach $uid(@uids)
	{
		$sth=$dbh->query("LOCK TABLES pw_ip_$uid WRITE") if ($locktables);
		$sth=$dbh->query("DELETE FROM pw_ip_$uid");
		$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	}
}
&systools;
}
sub closedb
{
$sth="";
$dbh="";
}
