#!/usr/bin/perl
use Mysql;

#    PollWorld SQL v1.3 - poll management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<pw.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}

$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);
$returnlink=$ENV{HTTP_REFERER};
read (STDIN,$query,$ENV{CONTENT_LENGTH});
@query=split("&",$query);
foreach (@query)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9A-Fa-f]{2})/pack('C',hex($1))/eg;
		if ($data{$field}){$data{$field}.=",$value";}
		else {$data{$field}=$value;}
	}
}
$returnlink=$data{x_url} if (!$returnlink && $data{x_url});
@data=split("; ",$ENV{HTTP_COOKIE});
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex ($1))/eg;
		$cookie{$field}=$value;
	}
}
if (!$data{id} || !$data{uid} || !$data{variant})
{
print "HTTP/1.0 200 OK\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
print qq~WRONG POLL HTML CODE $data{id} $data{name} $data{variant}~;
&closedb;
exit;
}
$temp="pollworld$data{uid}\_$data{id}";
$sth=$dbh->query("LOCK TABLES pw_polls READ") if ($locktables);
$sth=$dbh->query("SELECT pid,rdig,delay FROM pw_polls WHERE (pid=$data{id} AND uid=$data{uid})");
($pid,$cook,$tlim)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
unless ($pid)
{
print "HTTP/1.0 200 OK\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
print qq~UNKNOWN POLL~;
&closedb;
exit;
}
if ($tlim)
{
$ip=$ENV{REMOTE_ADDR};
($day,$month,$date,$time,$year)=split(" ",scalar localtime);
$date="0$date" if (length($date)==1);
$month=$cal{$month};
$month="0$month" if (length($month)==1);
$nowdate="$year-$month-$date $time";
($day,$month,$date,$time,$year)=split(" ",scalar localtime(time+$tlim*60));
$date="0$date" if (length($date)==1);
$month=$cal{$month};
$month="0$month" if (length($month)==1);
$newdate="$year-$month-$date $time";
$sth=$dbh->query("LOCK TABLES pw_ip_$data{uid} WRITE") if ($locktables);
$sth=$dbh->query("SELECT ipid FROM pw_ip_$data{uid} WHERE (pid=$data{id} AND ip='$ip')");
$ipid=$sth->fetchrow;
if ($ipid)
{
	$sth=$dbh->query("SELECT ipid FROM pw_ip_$data{uid} WHERE (pid=$data{id} AND ip='$ip' AND expdt>'$nowdate')");
	$ipid=$sth->fetchrow;
	if ($ipid)
	{
		$nottoshow=1;
	}
	else
	{
		$sth=$dbh->query("UPDATE pw_ip_$data{uid} SET expdt='$newdate' WHERE (pid=$data{id} AND ip='$ip')");
	}
}
else
{
	$sth=$dbh->query("INSERT INTO pw_ip_$data{uid} (pid,ip,expdt) VALUES ($data{id},'$ip','$newdate')");
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
if ($nottoshow || ($cook && $cookie{$temp}==$cook))
{
&closedb;
print "HTTP/1.0 302 Found\n" if ($sysid eq "Windows");
print "set-cookie: $temp=$cook; \n" if ($cook);
print "Location: $returnlink\n\n";
exit;
}
$sth=$dbh->query("LOCK TABLES pw_stats_$data{uid} WRITE") if ($locktables);
$sth=$dbh->query("UPDATE pw_stats_$data{uid} SET hits=hits+1 WHERE (pid=$data{id} AND aid=$data{variant})");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
print "HTTP/1.0 302 Found\n" if ($sysid eq "Windows");
print "set-cookie: $temp=$cook; \n" if ($cook);
print "Location: $returnlink\n\n";
sub closedb
{
$sth="";
$dbh="";
}
